---
title: ':valid'
slug: 'Web/CSS/:valid'
tags:
  - CSS
  - Layout
  - Pseudo-class
  - Reference
  - Selector
  - Web
---
<div>{{CSSRef}}</div>

<p>The <strong><code>:valid</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> represents any {{HTMLElement("input")}} or other {{HTMLElement("form")}} element whose contents <a href="/en-US/docs/Web/Guide/HTML/HTML5/Constraint_validation">validate</a> successfully. This allows to easily make valid fields adopt an appearance that helps the user confirm that their data is formatted properly.</p>

<pre class="brush: css no-line-numbers notranslate">/* Selects any valid &lt;input&gt; */
input:valid {
  background-color: powderblue;
}</pre>

<p>This pseudo-class is useful for highlighting correct fields for the user.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Indicating_valid_and_invalid_form_fields">Indicating valid and invalid form fields</h3>

<p>In this example, we use structures like this, which include extra <code>&lt;span&gt;</code>s to generate content on; we'll use these to provide indicators of valid/invalid data:</p>

<pre class="brush: html notranslate">&lt;div&gt;
  &lt;label for="fname"&gt;First name *: &lt;/label&gt;
  &lt;input id="fname" name="fname" type="text" required&gt;
  &lt;span&gt;&lt;/span&gt;
&lt;/div&gt;</pre>

<p>To provide these indicators, we use the following CSS:</p>

<pre class="brush: css notranslate">input + span {
  position: relative;
}

input + span::before {
  position: absolute;
  right: -20px;
  top: 5px;
}

input:invalid {
  border: 2px solid red;
}

input:invalid + span::before {
  content: '✖';
  color: red;
}

input:valid + span::before {
  content: '✓';
  color: green;
}</pre>

<p>We set the <code>&lt;span&gt;</code>s to <code>position: relative</code> so that we can position the generated content relative to them. We then absolutely position different generated content depending on whether the form's data is valid or invalid — a green check or a red cross, respectively. To add a bit of extra urgency to the invalid data, we've also given the inputs a thick red border when invalid.</p>

<div class="notecard note">
<p><strong>Note</strong>: We've used <code>::before</code> to add these labels, as we were already using <code>::after</code> for the "required" labels.</p>
</div>

<p>You can try it below:</p>

<p>{{EmbedGHLiveSample("learning-area/html/forms/pseudo-classes/valid-invalid.html", '100%', 430)}}</p>

<p>Notice how the required text inputs are invalid when empty, but valid when they have something filled in. The email input on the other hand is valid when empty, as it is not required, but invalid when it contains something that is not a proper email address.</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>The color green is commonly used to indicate valid input. People who have certain types of color blindness will be unable to determine the input's state unless it is accompanied by an additional indicator that does not rely on color to convey meaning. Typically, descriptive text and/or an icon are used.</p>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Perceivable#Guideline_1.4_Make_it_easier_for_users_to_see_and_hear_content_including_separating_foreground_from_background">MDN Understanding WCAG, Guideline 1.4 explanations</a></li>
 <li><a href="https://www.w3.org/TR/UNDERSTANDING-WCAG20/visual-audio-contrast-without-color.html">Understanding Success Criterion 1.4.1 | W3C Understanding WCAG 2.0</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#selector-valid', ':valid')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>No change.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', '#selector-valid', ':valid')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Defines the semantics of HTML and constraint validation.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS4 Selectors', '#validity-pseudos', ':valid')}}</td>
   <td>{{Spec2('CSS4 Selectors')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("css.selectors.valid")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>Other validation-related pseudo-classes: {{ cssxref(":required") }}, {{ cssxref(":optional") }}, {{ cssxref(":invalid") }}</li>
 <li><a href="/en-US/docs/Learn/HTML/Forms/Form_validation">Form data validation</a></li>
 <li>Accessing the <a href="/en-US/docs/Web/API/ValidityState">validity state</a> from JavaScript</li>
</ul>
